//+------------------------------------------------------------------+
//|                       GoldenFinger.mq4                           |
//|                       Copyright  2010, StarLimit Software Corp. |
//|                       Created 29/12/2010 3:24AM                  |
//+------------------------------------------------------------------+

#property copyright "Copyright  2010, StarLimit Software Corp."
#property link "starlimit03@yahoo.com"

#property indicator_chart_window
#property indicator_buffers 2

extern int       Risk                             = 6;
extern int       LongWingding                     = 159;
extern int       ShortWingding                    = 159;
extern color     LongColour                       = Aqua;
extern color     ShortColour                      = Red;
extern int       LongWidth                        = 2;
extern int       ShortWidth                       = 2;
extern bool      Alerts                           = false;
extern int       AlertBar                         = 1;

double LongSignal[],ShortSignal[],Vd[];
double d1,d2,d3,d4,d5,d6,d7,d8,d9,d10;
int Long,Short;
int tf,i1,i2,i3,i4,i5,i6,i7,i8,i9;
string s9;
string TimeFrame[]={"0","M1","M5","M15","M30","H1","H4","D1","W1","MN"};

int init()
{IndicatorBuffers(3);
SetIndexStyle(0, DRAW_ARROW, STYLE_SOLID,LongWidth,LongColour);   
SetIndexArrow(0, LongWingding);
SetIndexBuffer(0, LongSignal);
SetIndexEmptyValue(0,0);
SetIndexStyle(1, DRAW_ARROW, STYLE_SOLID,ShortWidth,ShortColour);
SetIndexArrow(1, ShortWingding);
SetIndexBuffer(1, ShortSignal);
SetIndexEmptyValue(1,0);
SetIndexBuffer(2, Vd);
tf=(Period()==1)+(Period()==5)*2+(Period()==15)*3+(Period()==30)*4+(Period()==60)*5+(Period()==240)*6+(Period()==1440)*7+(Period()==10080)*8+(Period()==43200)*9;
Long=0; Short=0; s9=StringSubstr(Symbol(),0,6);
return(0);}

int deinit()
{return(0);}

int start()
{i5 = IndicatorCounted(); d7 = Risk * 2 + 3; d8 = Risk + 67; d9 = 33 - Risk; d10 = d7;
if (i5<0) {return(-1);} if(i5>0) {i5--;}
i6=Bars-i5-1;
   
for(i7 = i6; i7 > 0; i7--) {
      
      if((Long != 0 || Short != 0) && i7 <= 1)
  //     Comment(i7 + " Long=" + Long + " Short=" + Short);
    //  Comment("GoldFingerB >>> "+ LongSignal[i7] + "\n\nGoldFingerS >>> "+ ShortSignal[i7]);
      i2 = i7;
      d3 = 0;
      d4 = 0;

for(i2 = i7; i2 <= i7 + 9; i2++)  
         d4 += MathAbs(High[i2] - Low[i2]); 

      d3 = d4 / 10.0;
      i2 = i7;
      i1 = 0;

while(i2<i7+9 && i1<1) {if (MathAbs(Open[i2]-Close[i2+1])>=2*d3) {i1++;} i2++;}

      if(i1 >= 1)  
         i3 = i2;
      else
         i3 = -1;

      i2 = i7;
      i1 = 0;

while(i2 < i7 + 6 && i1 < 1) {if (MathAbs(Close[i2+3]-Close[i2])>=4.6*d3) {i1++;} i2++;}

      if(i1 >= 1)  
         i4 = i2;
      else
         i4 = -1;

      if(i3 > -1)      
         d10 = 3;
      else
         d10 = d7;

      if(i4 > -1)
         d10 = 4;
      else
         d10 = d7;

d1=100-MathAbs(iWPR(NULL,0,d10,i7));   // iWPR 
      
      Vd[i7] = d1;
      d5 = 0;
      d6 = 0;
      d2 = 0;

      if(d1 < d9) {
         for(i8 = 1;
             Vd[i7 + i8] >= d9
             && Vd[i7 + i8] <= d8; i8++) {
         }
         if(Vd[i7 + i8] > d8) {
            d2 = High[i7] + d3 / 2.0;
            d5 = d2;
         }
      }

      if(d1 > d8) {
         for(i8 = 1;
             Vd[i7 + i8] >= d9
             && Vd[i7 + i8] <= d8; i8++) {
         }
         if(Vd[i7 + i8] < d9) {
            d2 = Low[i7] - d3 / 2.0;
            d6 = d2;
         }
      }

      LongSignal[i7]  = 0;
      ShortSignal[i7] = 0;
      if (d6!=0 && Long==0)  {LongSignal[i7]  = d6-1*Point; Long=1; Short=0; }
      if (d5!=0 && Short==0) {ShortSignal[i7] = d5+1*Point; Short=1; Long=0; }
   }
 // Comment("Golden Finger Buy signal value is >>>  ",LongSignal[i7],"\n\n Golden Finger Sell signal value is >>>  ",ShortSignal[i7]);
   if (Alerts)
   {  
      static datetime lastAlert = 0;
      string add = timeFrameToString(Period())+" "+Symbol()+" ";
      if (lastAlert != Time[0] && LongSignal[AlertBar]!=0)  { Alert(s9, " ",TimeFrame[tf], " Golden Finger BUY");  SendMail(add+"Golden Finger",add+"Golden Finger BUY");  lastAlert=Time[0];} 
      if (lastAlert != Time[0] && ShortSignal[AlertBar]!=0) { Alert(s9, " ",TimeFrame[tf], " Golden Finger SELL"); SendMail(add+"Golden Finger",add+"Golden Finger SELL"); lastAlert=Time[0];} 
   }      
   return (0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}